module Vx
  module Common
    module AMQP
      module Consumer::Ack

        def ack!(multiple = false)
          instrumentation = {
            consumer_id:   self.class.consumer_id,
            consumer:      self.class.consumer_name,
            properties:    properties,
            multiple:      multiple,
          }
          self.class.session.channel.ack delivery_info.delivery_tag, multiple
          instrument("ack.consumer.amqp", instrumentation)
        end

        def nack!(multiple = false, requeue = false)
          instrumentation = {
            consumer_id:   self.class.consumer_id,
            consumer:      self.class.consumer_name,
            properties:    properties,
            multiple:      multiple,
            requeue:       requeue,
          }
          self.class.session.channel.ack delivery_info.delivery_tag, multiple, requeue
          instrument("nack.consumer.amqp", instrumentation)
        end

      end
    end
  end
end
